Effect.MoveAndResizeTo = Class.create();
Object.extend(Object.extend(Effect.MoveAndResizeTo.prototype, Effect.Base.prototype), {
  initialize: function(element, toTop, toLeft, toWidth, toHeight, filledContainer, autoHeight) {
    this.element      = $(element);
    this.autoHeight	= autoHeight;
    this.toWidth      = toWidth;  
    this.toHeight     = toHeight;     	   
    this.toTop        = toTop;
    this.toLeft       = toLeft;    
    this.originalTop  = parseFloat(Element.getStyle(this.element,'top')  || 0);
    this.originalLeft = parseFloat(Element.getStyle(this.element,'left') || 0);
    this.originalWidth  = parseFloat(Element.getStyle(this.element,'right')  || 0);
    this.originalHeight = parseFloat(Element.getStyle(this.element,'bottom') || 0);
    this.effectiveTop = this.toTop;
    this.effectiveLeft = this.toLeft;
    this.effectiveWidth = this.toWidth;
                          
    this.options = arguments[arguments.length-1] || {};
    if (this.effectiveWidth < 0) this.effectiveWidth = 0;
    if (this.originalTop == this.effectiveTop &&
        this.originalLeft == this.effectiveLeft &&
        this.originalWidth == this.effectiveWidth &&
        (this.originalHeight == this.effectiveHeight)) {
      // no need to start!
      return;
    }
    this.start(this.options);
  },
  update: function(position) {
    topd  = this.effectiveTop * (position) + this.originalTop * (1 - position);
    leftd = this.effectiveLeft * (position) + this.originalLeft * (1 - position);
    widthd  = this.effectiveWidth * (position) + this.originalWidth * (1 - position);    
    heightd = this.effectiveHeight * (position) + this.originalHeight * (1 - position);
    this.setPosition(topd, leftd, widthd, heightd);    
  },
  setPosition: function(topd, leftd, widthd, heightd) {
    this.element.style.top = topd+'px';
    this.element.style.left = leftd+'px';    
    if(parseFloat(widthd || 0) != 0)this.element.style.right = widthd+'px';
    if(parseFloat(heightd || 0) != 0)this.element.style.bottom = heightd+'px';  
  }
});